
# R code chunk 1
2+2 # R WILL RETURN 4
2*2 # R WILL RETURN 4
2*2+6 # R WILL RETURN 10
6+2*2 # R WILL RETURN 10, IT KNOWS THE ORDER OF OPERATIONS
6+(2*2) # R ALSO RECOGNIZES BRACKETS
"AFS CONTINUING EDUCATION COURSES R FUN!" # R WILL RETURN THE TEXT


# R code chunk 2
##### THIS IS MY FIRST R SCRIPT
##### ANYTHING I TYPE TO THE RIGHT OF THE # SIGN IS IGNORED BY R
##### I CAN ANNOTATE AS MUCH OR AS LITTLE IS NEEDED
#####
##### ANALYST: JOE BIOLOGIST, JOE.BIOLOGIST@STATEAGENCY.GOV
##### DATE: 1 JULY 2008

# R code chunk 3
?mean # Works! mean is an R command
help(mean) # Works! mean is an R command
help(regression) # Fails! regression is not an R command
help.search("regression") # Well that works alright
RSiteSearch("regression") # We can also look at the R archive on the web

# R code chunk 4
install.packages("package")
require(package)
update.packages() # UPDATES INSTALLED PACKAGES

# R code chunk 5
install.packages("car")
install.packages("RODBC")
install.packages("gplots")
install.packages("maptools")
install.packages("pda",repos="http://R-Forge.R-project.org")

# R code chunk 6
x<- c(1,2,3,4,5,6,7,8)
X<- c(2,3,4,5,10,12,14)# R is case senstive
x<- as.vector(c(1,2,3,4,5,6,7,8)) # Make a vector named x
x[1] # Get the first value from the vector
x[1:3] # Get values 1 to 3 from the vector
str(x)
str(X)
summary(x)

# R code chunk 7
##### Dataframes are probably the most similar to an excel database
##### Dataframes are required to have the same number of 
##### rows for each column
mydataframe<- data.frame(
x= c(1,2,3,4,5),
lake=c("Clear","Clear","Spirit","Spirit","Spirit"),
y= c(2.2,3.1,5.3,6.9,3.1))
mydataframe[c(1:5),] # returns the first 5 rows of the dataframe
mydataframe[c(1:5),c(3)] # first 5 rows of the 3rd field
names(mydataframe) # returns the field names
mydataframe$group # returns all the values for the group column
str(mydataframe)
dim(mydataframe)
summary(mydataframe)

# R code chunk 8
##### Lists offer more flexibility since they can be "ragged"
##### they are useful for holding simulation and summary data
mylist<- list(lake = c("Wall Lake"), secchiTransparency= c(0.2,0.3,0.25),
fishLength=c(11,12,14,11,30,22.3,40,29))
names(mylist) # returns names of elements
mylist$lake
mylist[[2]] # returns second vector in the list secchiTransparency
mylist$fishLength[1] # Get the first value from fishLength
mylist[[3]][1] # Same as previous
str(mylist)
summary(mylist)

# R code chunk 9
read.delim("C:/contEdCourseData/part1/book1.txt", header = TRUE, sep =
"\t")
read.csv("C:/contEdCourseData/part1/book1.csv", header=T)

# R code chunk 10
tabdelim_dataset<-read.delim("C:/contEdCourseData/part1/book1.txt", header =
TRUE, sep = "\t")
tabdelim_dataset # RETURNS THE ENTIRE DATASET TO THE CONSOLE
head(tabdelim_dataset) # SHOWS THE FIRST FIVE ROWS OF THE DATASET
summary(tabdelim_dataset) # SUMMARIZES THE DATASET

# R code chunk 11
csv_dataset<-read.csv("C:/contEdCourseData/part1/book1.csv", header=T)
csv_dataset
str(csv_dataset)
dim(csv_dataset)
head(csv_dataset)
summary(csv_dataset)

# R code chunk 12
# install.packages("RODBC") # already run previously to install
require(RODBC)

# R code chunk 13
channel<-odbcConnectExcel("C:/contEdCourseData/part1/book1.xls", readOnly=T)
sqlFetch(channel, "Sheet1")
excel_dataset<- sqlFetch(channel,"Sheet1")
head(excel_dataset)
summary(excel_dataset)

# R code chunk 14
channel_access<- odbcConnectAccess("C:/contEdCourseData/part1/book1.mdb")
sqlFetch(channel_access,"Book1")
access_dataset<- sqlFetch(channel_access,"Book1")
head(access_dataset)
str(access_dataset)
summary(access_dataset)


R code chunk 15
##### Setting a new working directory
getwd() # Gets the current working directory
setwd("C:/contEdCourseData/part1/") # sets the new working directory
##### We can now read in a file using a period
read.csv("./book1.csv") # this saves lots of typing

# R code chunk 16
###### lets save our analysis file
write.csv(excel_dataset, "./filename.csv")

# R code chunk 17
# IMPORT TRAWL CATCH DATA
trawlData_csv<-read.csv("./trawlData.csv")
channel<- odbcConnectExcel("./trawlData.xls")
trawlData<- sqlFetch(channel, "data")
# HOW BIG IS THE DATASET?
dim(trawlData)
# WHAT ARE THE DIMENSIONS OF THE DATASET?
str(trawlData)
# LETS LOOK AT THE FIRST 5 ROWS OF THE DATASET
head(trawlData)
# WHAT ARE THE NAMES OF THE FIELDS IN THE DATASET?
names(trawlData)

# R code chunk 18
# SOME BASIC STATISTICS FOR FISH LENGTHS
mean(trawlData$fishLength) # mean of fish lengths
min(trawlData$fishLength) # min of fish lengths
max(trawlData$fishLength) # maximum of fish lengths
range(trawlData$fishLength) # range of fish lengths
var(trawlData$fishLength) # variance of fish lengths
sd(trawlData$fishLength) # standard deviation of fish lengths
length(trawlData$fishLength) # how many observations?
summary(trawlData$fishLength) # summarize fish lengths

# R code chunk 19
summary(trawlData$fishWeight)
# SOME BASIC STATISTICS FOR FISH LENGTHS
mean(trawlData$fishWeight, na.rm=TRUE) # mean of fish weight
min(trawlData$fishWeight, na.rm=TRUE) # min of fish weight
max(trawlData$fishWeight, na.rm=TRUE) # maximum of fish weight
range(trawlData$fishWeight, na.rm=TRUE) # range of fish weight
var(trawlData$fishWeight, na.rm=TRUE) # variance of fish weight
sd(trawlData$fishWeight, na.rm=TRUE) # standard dev. of fish weight

# R code chunk 20
# WHAT FACTOR LEVELS ARE THERE FOR FISH SPECIES?
summary(trawlData$species)
levels(trawlData$species)
# LETS LOOK AT SITES
summary(trawlData$sites) # it is a integer and is should be a factor
trawlData$sites<- as.factor(trawlData$sites) # convert numeric to a factor

# R code chunk 21
# TABLULATE COUNTS OF FISH BY SPECES
table(trawlData$species) # species count
table(trawlData$basin) # count by lake basin
# TABULATE BASIN BY SPECIES
xtabs(~basin + species, trawlData)

# R code chunk 22
# SUMMARIZE MEAN FISH LENGTH BY BASIN
tapply(trawlData$fishLength, trawlData$basin, mean)
# SUMMARIZE FISH LENGTH VARIANCE BY BASIN
tapply(trawlData$fishLength, trawlData$basin, var)
# SUMMARIZE MEAN FISH LENGTH BY SPECIES
tapply(trawlData$fishLength, trawlData$species, mean)
# WHAT ABOUT WEIGHT
tapply(trawlData$fishWeight, trawlData$species, mean)
tapply(trawlData$fishWeight, trawlData$species, mean, na.rm=TRUE)
# WHAT ABOUT A SPECIES BY BASIN BY YEAR SUMMARY?
# WE NEED TO MAKE A UNIQUE BASIN AND SPECIES INDEX
trawlData$index<- paste(trawlData$year, trawlData$basin, trawlData$species)
# USING THE NEW INDEX VARIABLE WE CAN SUMMARIZE AS BEFORE
tapply(trawlData$fishLength, trawlData$index, mean)

# R code chunk 23
# MAKING A SUMMARY TABLE FOR AN ANNUAL REPORT
summaryTable<- data.frame( # lets use a dataframe for this
year= tapply(trawlData$year, trawlData$index, unique),
basin= tapply(as.character(trawlData$basin), trawlData$index, unique),
species= tapply(as.character(trawlData$species), trawlData$index,
unique),
meanLength= tapply(trawlData$fishLength, trawlData$index, mean),
minLength= tapply(trawlData$fishLength, trawlData$index, min),
maxLength= tapply(trawlData$fishLength, trawlData$index, max))
# NOW WE CAN SAVE THIS TO PUT IN OUR REPORT
write.csv(summaryTable, "./summaryTable.csv")
# THIS SCRIPT CAN NOW BE RERUN EACH YEAR!

# R code chunk 24
ifelse(trawlData$fishLength > 500 , 1, 0)
trawlData$aggBasins<- ifelse(trawlData$bassin %in% c("little",
"middle"),"Western","Eastern")
trawlData$carp<-ifelse(trawlData$species=="CRP", 1,0)
mean(trawlData$carp) # percent of the catch that was carp
trawlData$carp_bullhead<-ifelse(trawlData$species=="CRP"|trawlData$species=="BBH",
1,0)
# percent of the catch that was carp or bullhead
mean(trawlData$carp_bullhead) 
mean(ifelse(trawlData$species%in%c("CRP","BBH"), 1,0))# same as above

# R code chunk 25
subset(trawlData, species==c("CRP"))
subset(trawlData, fishLength >250)
subset(trawlData, (species==c("CRP") & fishLength >250))
subset(trawlData, species %in% c("CRP","BBH","BUF"))
subset(trawlData, species != c("CRP"))
##### If the dataset is subset by a factor,
##### we should to drop the unused factor
##### or else it R will give summaries, ect for that factor level
trawlNoCarp<- subset(trawlData, species != c("CRP"))
tapply(trawlNoCarp$fishLength, trawlNoCarp$species, mean) 
# WHY THE NA FOR CARP? 
trawlNoCarp$species<- trawlNoCarp$species[,drop=T]
tapply(trawlNoCarp$fishLength, trawlNoCarp$species, mean) # carp are gone!

# R code chunk 26
# READ IN QUALITY LENGTH AND STOCK LENGTH TABLE FOR EACH FISH SPECIES
psdData<-read.csv("./psdData.csv")
psdData # look at the data

# THE FISH SPECIES CODE IS UNIQUE FOR EACH SPECIES AND
# MATCHES THE SPECIES CODES USED IN psdData
trawlData<- merge(trawlData, psdData, by.x="species", by.y="species",
all.x=TRUE)
head(trawlData) # dataset has the appropriate values needed to calculate PSD

# CALCULATE PSD
trawlData$stockLength<-ifelse(trawlData$fishLength>trawlData$stockLength,1,0)
trawlData$qualityLength<-ifelse(trawlData$fishLength>trawlData$qualityLength,1,0)
overallSummary<- data.frame(
	spp = tapply(as.character(trawlData$commonName), trawlData$index,unique),
	year= tapply(trawlData$year, trawlData$index,unique),
	n_Qual = c(tapply(trawlData$qualityLength, trawlData$index,sum,na.rm=TRUE)),
	n_Stock = c(tapply(trawlData$stockLength, trawlData$index,sum,na.rm=TRUE)))

# R code chunk 27
boxplot(fishLength~lake, catchData)
boxplot(fishLength~lake, catchData, main="Boxplot of fish lengths")
boxplot(fishLength~lake, catchData, main="Boxplot of fish lengths",
xlab="Lake",ylab="Fish Length (mm)")
# ADD SOME COLOR
boxplot(fishLength~lake, catchData, main="Boxplot of fish lengths",
xlab="Lake",ylab="Fish Length (mm)",col="red")
# CAN WE SUBSET?
boxplot(fishLength~lake, catchData, main="Boxplot of fish lengths",
xlab="Lake",ylab="Fish Length (mm)",col="red", subset=lake !="Lake c")

# R code chunk 28
##### A histogram of all the fish lengths
hist(trawlData$fishLength)
savePlot("./lengthFreq",type="jpg")

# SOME INTERVALS TO BIN FISH LENGTHS INTO
bins<- seq(0,1000, by=25)
bins
# LENGTH FREQUENCY HISTOGRAM
hist(trawlData$fishLength, breaks=bins, include.lowest=T)
# A DENSITY PLOT
hist(trawlData$fishLength, breaks=bins, include.lowest=T, freq=F)
# LETS ADD A TITLE
hist(trawlData$fishLength, breaks=bins, include.lowest=T, freq=F,
main="Lenght frequency plot", xlab="Length (mm)",ylab="Density")
# LETS MAKE THE BARS BLACK
hist(trawlData$fishLength, breaks=bins, include.lowest=T, freq=F,
main="Lenght frequency plot", xlab="Length (mm)",ylab="Density",
col="black")
savePlot("./lengthFrequency",type="jpg")

# R code chunk 29
summaryTable
sum_2007<- subset(summaryTable, (year==2007& basin=="Middle"))
sum_2008<- subset(summaryTable, (year==2008& basin=="Middle"))
barplot(sum_2007$meanLength, names.arg=sum_2007$species )
barplot(sum_2007$meanLength, names.arg=sum_2007$species, col="blue")
barplot(sum_2007$meanLength, names.arg=sum_2007$species, col="blue", las=2)
barplot(sum_2007$meanLength, names.arg=sum_2007$species, density=20, las=2)

# R code chunk 30
plot(fishWeight~fishLength, trawlData)
# add a title
plot(fishWeight~fishLength, trawlData, main="Weight-Length for fish")
# add better axis labels
plot(fishWeight~fishLength, trawlData, main="Weight-Length for fish",
xlab="Length (mm)", ylab="Weight (g)")
# We can copy and paste this directly into MS Word
##### Lets add some grouping
plot(fishWeight~fishLength, trawlData, main="Weight-Length for fish",
xlab="Length (mm)", ylab="Weight (g)",type="n")
points(fishWeight~fishLength, trawlData,subset=species=="CRP",col="red")
points(fishWeight~fishLength, trawlData,subset=species=="YLB", col="blue")
points(fishWeight~fishLength, trawlData,subset=species=="WAL", col="green")
points(fishWeight~fishLength, trawlData,subset=species=="BBS", col="black")

##### Lets add some grouping with different points
plot(fishWeight~fishLength, trawlData, main="Weight-Length for fish",
xlab="Length (mm)", ylab="Weight (g)",type="n")
points(fishWeight~fishLength, trawlData,subset=species=="CRP",col="red", pch=1)
points(fishWeight~fishLength, trawlData,subset=species=="YLB", col="blue", pch=2)
points(fishWeight~fishLength, trawlData,subset=species=="WAL", col="green", pch=3)
points(fishWeight~fishLength, trawlData,subset=species=="BBS", col="black", pch=4)


# R code chunk 31
# THE POINTS NEED TO BE BIGGER AND FILLED
# CEX IS A MAGNIFICATION FACTOR AND PCH 1-25 ARE ALL SORTS OF SYMBOLS
plot(fishWeight~fishLength, trawlData,cex=2,pch=19)
# MY BOSS WANTS BIGGER FONT FOR THE LABELS
# CEX.AXIS IS A MAGNFICATION FOR THE AXIS FONT
# CEX.LAB IS A MAGFICIATION FOR THE LABEL FONT
plot(fishWeight~fishLength,trawlData,cex=1.5,pch=19,
cex.axis=1.1,cex.lab=1.2,xlab="Fish length(mm)")
# PERSONALLY, I DISLIKE HAVING THE NUMBERS ON THE YAXIS
# ORIENTED PARRELLELL TO THE AXIS
# LAS=1 FIXES THAT
plot(fishWeight~fishLength,trawlData,cex=1.5,pch=19,
cex.axis=1.1,cex.lab=1.2,xlab="Fish length(mm)",ylab="Weight (g)", las=1)

# R code chunk 32
##### Lets add some grouping with different points 
plot(fishWeight~fishLength,trawlData, main="Weight-Length for fish", 
	xlab="Length (mm)",
ylab="Weight (g)",type="n") 
points(fishWeight~fishLength,trawlData,subset=species=="CRP",col="red",
	pch=1)
points(fishWeight~fishLength, trawlData,subset=species=="YLB", col="blue",
	pch=2)
points(fishWeight~fishLength, trawlData,subset=species=="WAL", col="green",
	pch=3) 
points(fishWeight~fishLength, trawlData,subset=species=="BBS",col="black",
	pch=4)
legend("topleft", c("Common carp", "Yellow bass", "Walleye", "Black bullhead"),
pch=c(1,2,3,4),col=c("red","blue", "green", "black"))


# R code chunk 33
add<-function(var1,var2,var3){var1+var2+var3}
add(4,6,20)
# A SUMMARY FUNCTION
var_summary<- function(var1,var2){
	par(mfrow=c(2,1))
	hist(var1);savePlot("./hist1",type="pdf")
	hist(var2);savePlot("./hist2",type="pdf")
	mean(var1, na.rm=T)
	mean(var2, na.rm=T)
}
##### Use the function to summarize a dataset
var_summary(trawlData$fishLength,trawlData$fishLength)

# R code chunk 34
require("car")
fit<- lm(fishWeight~fishLength ,trawlData) # fits a linear regression
plot(fit)# diagnostics
# LOG TRANSFORM VARIABLES
trawlData$lweight<- log(trawlData$fishWeight)
trawlData$llength<- log(trawlData$fishLength)
fit<- lm(lweight~llength ,trawlData)
plot(fit)
summary(fit) # returns information about the model fit
anova(fit)# returns an anova table
Anova(fit, type="III")
Y_hats<- fit$fitted # extracts the predicted values
residuals<- fit$resid # extracts the residuals
confint(fit)
# ADD A SPECIES INTERACTION
fit<- lm(lweight~llength*species ,trawlData)
plot(fit)
summary(fit) # returns information about the model fit
anova(fit)# returns an anova table
Anova(fit)
confint(fit)

# R code chunk 35
# FIT A NON LINEAR REGRESSION
fit<- nls(fishWeigth~a*fishLength^b ,trawlData, start=list(a=0.0001, b=3))
summary(fit)
# A WEIGHT-LENGTH RELATIONSHIP FOR CARP
fit<- nls(fishWeight~a*fishLength^b ,trawlData, start=list(a=0.00004,b=3),
	subset=species=="CRP")
summary(fit)



