
# R code chunk 36 Estimate Z from population metrics (Hayes et al., 2007)
setwd("C:/contEdCourseData/part2")
lengths <- read.csv("./box6_8.csv")
head(lengths)
hist(lengths$len/10,xlab="Length (cm)")
bins<- seq(9,53, by=1)
h<-hist(lengths$len/10,breaks=bins, right=FALSE, xlab="Length (cm)")
Linf <- 636
K <- 0.226
meanLength <- mean(lengths$len)
minLength <- min(lengths$len)
Z_bevertonHolt <- K * (Linf - meanLength)/(meanLength - minLength)
Z_bevertonHolt
medLength <- median(lengths$len)
Ymedian <- -log(1 - medLength/Linf)
Ymin <- -log(1 - minLength/Linf)
Z_Hoenig <- 0.693 * K/(Ymedian - Ymin)
Z_Hoenig

# R code chunk 37 Age length key (Isely and Grabowski, 2007).
setwd("C:/contEdCourseData/part2")
key <- read.csv("./box5_1.csv")
lengths <- read.csv("./box5_1_lengthData.csv") 
str(lengths)
key$tlint<- ifelse(key$tl< 100, 90, 0)
key$tlint<- ifelse(key$tl>=100 & key$tl< 120, 100, 0)
key$tlint<- ifelse(key$tl>=120 & key$tl< 140, 120, 0)
key$tlint<- ifelse(key$tl>=140 & key$tl< 160, 140, 0)
key$tlint<- ifelse(key$tl>=160 & key$tl< 180, 160, 0)
key$tlint<- ifelse(key$tl>=180 & key$tl< 200, 180, 0)
key$tlint<- ifelse(key$tl>=200 & key$tl< 220, 200, 0)
key$tlint<- ifelse(key$tl>=220 & key$tl< 240, 220, 0)
key$tlint<- ifelse(key$tl>=240 & key$tl< 260, 240, 0)
key$tlint<- ifelse(key$tl>=260 & key$tl< 280, 260, 0)
key$tlint<- ifelse(key$tl>=280 & key$tl< 300, 280, 0)
key$tlint<- ifelse(key$tl>=300 & key$tl< 320, 300, 0)
key$tlint<- ifelse(key$tl>=320 & key$tl< 340, 320, 0)
key$tlint<- ifelse(key$tl>=340 & key$tl< 360, 340, 0)
key$tlint<- ifelse(key$tl>=360 & key$tl< 380, 360, 0)
key$tlint<- ifelse(key$tl>=380 & key$tl< 400, 380, 0)
key$tlint<- ifelse(key$tl>=400 & key$tl< 420, 400, 0)
key$tlint<- ifelse(key$tl>=420 & key$tl< 440, 420, 0)
key$tlint<- ifelse(key$tl>=440 & key$tl< 460, 440, 0)
key$tlint<- ifelse(key$tl>=460 & key$tl< 480, 460, 0)
key$tlint<- ifelse(key$tl>=480 & key$tl< 500, 480, 0)
key$tlint<- ifelse(key$tl>=500 & key$tl< 520, 500, 0)
key$tlint<- ifelse(key$tl>=520 & key$tl< 540, 520, 0)
# AN EASIER WAY, THIS DOES THE SAME THING AS THE PREVIOUS 23 LINES
bins<- c(0,seq(100,540, by=20))
labels.x<- c(90, seq(100,520, by=20))
key$tlint<-cut(key$tl, breaks = bins, right=FALSE, include.lowest=TRUE,labels=labels.x)
summaryTable <- table(key$tlint, key$age)
ageLengthKey <- prop.table(summaryTable , margin = 1)
ageLengthKey[which(is.na(ageLengthKey ))]<-0
ageLengthKey <- round(ageLengthKey, digits=3)
lengths$tlint<-cut(lengths $tl, breaks = bins, right=FALSE,
include.lowest=TRUE,labels=labels.x)
lengths<- subset(lengths, tl<520)
len.freq <- table(lengths$tlint)
dim(ageLengthKey)
length(len.freq)
# A LIST OF NUMBER OF FISH ASSIGNED TO EACH AGE GROUP
ageFrequency<-len.freq %*% ageLengthKey
ageFrequency

# R code chunk 38 Back calculated length (Isely and Grabowski, 2007).
setwd("C:/contEdCourseData/part2")
backCalc <- read.csv("./box5_2.csv")
str(backCalc)
head(backCalc)
backCalc$Si2 <- backCalc$Si*10/24
# convert radial measurements
backCalc$Sc2 <- backCalc$Sc*10/24
# convert total scale radius
backCalc$Li1 <- backCalc$Lc * backCalc$Si2/backCalc$Sc2
# Fraser-Lee Method
fit <- lm(Li1 ~ Si2, backCalc) 
anova(fit)
a <- coef(fit)[1] # get the correction factor (first coefficient in lm1)
backCalc$Li2 <- a + (backCalc$Lc-a)*(backCalc$Si2/backCalc$Sc2)

# R code chunk 39 Estimating the age composition form a random sample of brown trout (Page 63
# Hansen et al., 2007).
ageData<- data.frame(
age=c(0,1,2,3,4,5,6,7),
n=c(55,22,10,18,6,3,1,1))
totalNumberOfTrout<-sum(ageData$n)
ageProportion<- ageData$n/totalNumberOfTrout
# CALCULATED PROPORTION
seAgeProportion<- sqrt(ageProportion*(1-ageProportion)/(totalNumberOfTrout-1))
# STANDARD ERROR OF THE ESTIMATE
# FUNCTIONS TO CALCULATE CONFIDENCE INTERVALS
lowerCI<- function(ageCounts, alpha){
N<- sum(ageCounts)
lowerF<-qf(alpha,2*(N-ageCounts+1),2*ageCounts,lower.tail = FALSE)
ageCounts/(ageCounts+(N-ageCounts+1)*lowerF) }
upperCI<- function(ageCounts, alpha){
# TO RUN THIS FUNCTION INPUT A VECTOR OF AGE COUNTS
# AND AN ALPHA VALUE
N<- sum(ageCounts)
upperF<-qf(alpha,(2*ageCounts)+2,(2*(N-ageCounts+1)-2),lower.tail=FALSE)
((ageCounts+1)*upperF)/(N-ageCounts+(ageCounts+1)*upperF)
}# END FUNCTION
# END FUNCTIONS TO CALCULATE CONFIDENCE INTERVALS
# ENTER A VECTOR OF AGE COUNTS AND AN ALPHA TO CALCULATE CONFIDENCE LIMITS
lowerCL<-lowerCI(ageData$n,0.05)
upperCL<-upperCI(ageData$n,0.05)
# CREATE A SUMMARY TABLE
summaryTable<- data.frame(
age=ageData$age, proportion_age=ageProportion,
SE=seAgeProportion, LowerCL=lowerCL, UpperCL=upperCL)
summaryTable"
write.csv("./summaryTableRandomSample.csv")

# R code chunk 40 Estimate the mean catch from a stratified radom sample (Hansen et al., 2007).
setwd("C:/contEdCourseData/part2")
srs<- read.csv("./box3_4.csv")
# CALCULATE MEAN AND VARIANCE OF THE STRATA
stratumSummary<- data.frame(
stratum= tapply(as.character(srs$stratum),srs$stratum,unique),
n= tapply(srs$Catch,srs$stratum,length),
mean=tapply(srs$Catch,srs$stratum,mean),
variance=tapply(srs$Catch,srs$stratum,var))
stratumSummary$weights<- c(0.2125,0.5375,0.250)
meanCatch<- sum(stratumSummary$weights*stratumSummary$mean)
meanCatachSE<- sqrt(sum((stratumSummary$weights^2*stratumSummary$variance)/
stratumSummary$n))
CI<- meanCatachSE*qt(0.975,df=nrow(srs)-3)
lowerCI<-meanCatch- CI
upperCI<-meanCatch+ CI

# R code chunk 41 Estimation of the mean weight of age 0+ bluegill from a cluster sample (Hansen
# et al., 2007).
setwd("C:/contEdCourseData/part2")
cluster<- read.csv("./box3_5.csv")
cluster$countId<- ifelse(is.na(cluster$Weight)==TRUE,0,1)
summary<- data.frame(
net= tapply(as.character(cluster$Net),cluster$Net,unique),
catch= tapply(cluster$countId,cluster$Net,sum),
clusterTotal=tapply(cluster$Weight,cluster$Net,sum,na.rm=T))
numberOfNets<- nrow(summary)
meanCatch<- sum(summary$catch)/numberOfNets
meanWeight<- sum(summary$clusterTotal)/sum(summary$catch)
meanWeightSE<- (1/(sqrt(numberOfNets)*meanCatch))* sqrt(
sum((summary$clusterTotal-meanWeight*summary$catch)^2)/(numberOfNets-1))
CI<- meanWeightSE*qt(0.975,df=numberOfNets-1)
lowerCI<- meanWeight-CI
upperCI<- meanWeight+CI

# R code chunk 42 Estimate the mean width of a stream based on a systematic sampling design
# (Hansen et al., 2007) .
setwd("C:/contEdCourseData/part2")
systematic<- read.csv("./box3_6.csv")
clusterTotals<- tapply(systematic$width,systematic$sample,sum)
samplesWithinCluster<- tapply(systematic$sample,systematic$sample,length)
nclusters<- length(tapply(systematic$sample,systematic$sample,unique))
meanWidth<- mean(systematic$width)
meanWidthSE<- 1/(sqrt(2)*15)* sqrt((sum((clusterTotals-meanWidth*15)^2))/
(nclusters-1))


# R code chunk 43 Estimate the mean coverage of woody debris based on calibrated visual estimates
# (Hansen et al., 2007).
setwd("C:/contEdCourseData/part2")
regression<- read.csv("./box3_7.csv")
subset<- na.omit(regression)
measuredObs<- nrow(subset)
fit<- lm(Measured~Estimated,subset)
slope<- fit$coeff[2]
interecept<-fit$coeff[1]
xbar<- mean(subset$Estimated)
ybar<- mean(subset$Measured)
Xbar<- mean(regression$Estimated)
meanCoverage<- ybar+slope*(Xbar-xbar)
meanCoverageSE<- sqrt(1/(measuredObs*(measuredObs-2))*(sum((subset$Measured-ybar)^2)-
(sum((subset$Measured-ybar)*((subset$Estimated-xbar)^2))/
(sum((subset$Estimated-xbar)^2)))))


# R code chunk 44 Analysis evaluates differences catches based on bag limits that were randomly
# assigned to lakes (Hansen et al., 2007).
setwd("C:/contEdCourseData/part2")
crd<- read.csv("./box3_8.csv") # the data
require(car);require(pda) # packages needed for analysis
options(contrasts=c("contr.sum","contr.poly")) # this is needed to reproduce SAS results
str(crd) crd$bag_limit<- as.factor(crd$bag_limit)# make bag limit a factor
fit <- lm(catch ~ bag_limit, crd) # model of the data
plot(fit) # plot model diagonstics
anova(fit) # provides type I sums of squares
Anova(fit, type="III") # provides type III sums of squares
lsmean(fit, level=0.05, pdiff=T) # evaluates differences in lsmeans


# R code chunk 45 Diagnostics and assumptions Hansen et al. (2007).
setwd("C:/contEdCourseData/part2")
residuals<- residuals(fit) # extract residuals from the previous model
summary(residuals)
hist(residuals) # histgram of residuals
qqnorm(residuals) # plot of qqnorm
shapiro.test(residuals) # test for normality
ks.test(residuals, "pnorm") # ks test
boxplot(residuals~crd$bag_limit) # boxplot of residals by bag limit factor
abline(h=0,col="red") # add a red line to the previous plot

# R code chunk 46 Randomized block design (Hansen et al., 2007). Page 93
setwd("C:/contEdCourseData/part2")
require(car);require(pda) ; require(gplots)
options(contrasts=c("contr.sum","contr.poly"))
rbd<- read.csv("./box3_10_2.csv")
rbd$bag_limit<- factor(rbd$bag_limit)
fit <- lm(catch ~ region*bag_limit, rbd)
Anova(fit , type="III")
lsmean(fit,factors="region")
lsmean(fit,factors="bag_limit")
# DROP THE INSIGNIFICANT INTERACTION TERM
fit <- lm(catch ~ region+ bag_limit, rbd)
Anova(fit, type="III")
lsmean(fit,factors="region", level=0.05, pdiff=T)
lsmean(fit,factors="bag_limit", level=0.05, pdiff=T)
interaction.plot(rbd$bag_limit,rbd$region, rbd$catch,type="b", xlab="Bag
Limit",ylab="Catch", trace.label ="Region")
# Plot Means with Error Bars
require(gplots)
plotmeans(catch~bag_limit,rbd, xlab="Walleye bag limit", ylab="Catch",
main="Mean Plot with 95% CI",las=1)

# R code chunk 47 Analysis of covariance (Hansen et al., 2007).
setwd("C:/contEdCourseData/part2")
require(car);require(pda)
options(contrasts=c("contr.sum","contr.poly"))
ancova<- read.csv("./box3_11.csv")
plot(growth~egg_diameter, ancova)
points(growth~egg_diameter, ancova,subset=substrate=="Sand",col="red")
points(growth~egg_diameter, ancova,subset=substrate=="Gravel",col="blue")
points(growth~egg_diameter, ancova,subset=substrate=="Cobble",col="black")
fit<- lm(growth~egg_diameter*substrate, ancova)
summary(fit)
Anova(fit, type="III")
ancova$predicted<- fitted(fit)
# ADD FITTED LINES TO THE PREVIOUS PLOT
points(predicted~egg_diameter, ancova,subset=substrate=="Sand",
col="red",type="l")
points(predicted~egg_diameter, ancova,subset=substrate=="Gravel",
col="blue",type="l")
points(predicted~egg_diameter, ancova,subset=substrate=="Cobble",
col="black",type="l")

# R code chunk 48 Factorial model anlaysis (Hansen et al., 2007).
setwd("C:/contEdCourseData/part2")
require(car); require(pda)
options(contrasts=c("contr.sum","contr.poly"))
factorial<- read.csv("./box3_13.csv")
factorial$survival<- asin(factorial$survival/100)
fit<- lm(survival~size*release, factorial)
Anova(fit, type="III")
lsmean(fit)

# R code chunk 49 Contingency table for differences in lenght frequency data (Neumann and Allen,
# 2007).
setwd("C:/contEdCourseData/part2")
meanLength <- read.csv("./box9_5.csv")
str(meanLength) 
meanLength
x<-xtabs(num~year + lcat, meanLength)
chisq.test (x)
x<-xtabs(num~year + lcat, meanLength, subset=year %in% c(1996,1998))
summary(x)
x<-xtabs(num~year + lcat, meanLength, subset=year %in% c(1996,2000))
summary(x)
x<-xtabs(num~year + lcat, meanLength, subset=year %in% c(1998,2000))
summary(x)
bon.alpha<-0.05/3

# R code chunk 50 Correlation simple regression and multiple regression (Hansen et al., 2007).
setwd("C:/contEdCourseData/part2")
require(car);require(pda);require(lmtest);require(agricolae);require(MPV)
options(contrasts=c("contr.sum","contr.poly"))
regression <- read.csv("./box4_5.csv")
regression str(regression)
plot(CPE0~WINSTAGE, regression)
plot(CPE0~WINRET, regression)
plot(CPE0~SPRSTAGE, regression)
cor(regression[,c(2,4,5,6)], method="pearson",use="pairwise.complete.obs")
fit1<- lm(CPE0~WINSTAGE +WINRET +SPRSTAGE, regression)
anova(fit1)
summary(fit1)
Anova(fit1,type="II")
vif(fit1)
fit2<- lm(CPE0~WINSTAGE+ SPRSTAGE, regression)
Anova(fit2,type="II")
fit3<- lm(CPE0~WINSTAGE, regression)
Anova(fit3,type="II")

# R code chunk 51 Log linear model to test for year class abundance differences (Hansen et al.,
# 2007).
setwd("C:/contEdCourseData/part2")
require(car);require(pda);require(agricolae)
options(contrasts=c("contr.sum","contr.poly"))
llinear<- read.csv("./box4_1.csv")
str(llinear)
llinear$YEARCL <- as.factor(llinear$YEARCL)
llinear$AGE<- as.factor(llinear$AGE)
fit<- lm(log(CATCH)~YEARCL + AGE, llinear)
anova(fit)
Anova(fit, type="III")
lsmean(fit, factors="YEARCL", pdiff=T, level=0.001786)
x<-pairwise.t.test(log(llinear$CATCH),llinear$YEARCL, paired=T,p.adj =
"bonf")
df<-df.residual(fit)
MSerror<-deviance(fit)/df
comparison <- LSD.test(log(llinear$CATCH),llinear$YEARCL,df,MSerror,
p.adj="none",alpha=0.00176, group=FALSE, main=" ")

# R code chunk 52 Evaluation of time series trneds in abundance (Hansen et al., 2007).
setwd("C:/contEdCourseData/part2")
require(car);require(pda);require(lmtest)
options(contrasts=c("contr.sum","contr.poly"))
timeSeries<- read.csv("./box4_2.csv")
str(timeSeries)
timeSeries<- subset(timeSeries, YEAR>1971)
plot(AGE0CPE~YEAR, timeSeries)
summary(timeSeries)
cor(timeSeries, method="pearson")
cor(timeSeries, method="kendall")
fit<- lm(AGE0CPE~YEAR, timeSeries)
summary(fit)
anova(fit)
x<-acf(residuals(fit))
plot(x)
x
dwtest(fit)# DURBIN WATSON TEST FOR AUTOCORRELLATION

# R code chunk 53 Catch curve regression to identify week and strong year classes (Hansen et al.,
# 2007).
setwd("C:/contEdCourseData/part2")
require(car);require(pda);require(lmtest);require(agricolae);require(MPV)
options(contrasts=c("contr.sum","contr.poly"))
catchCurve <- read.csv("./box4_4.csv")
catchCurve$LNUM<- log(catchCurve$NUM+1)
catchCurve$LMEANRET<- log10(catchCurve$MEANRET)
fit<- lm(LNUM~AGE, catchCurve)
catchCurve$Weight<-fitted(fit)
fit<- lm(LNUM~AGE, catchCurve, weights=Weight)
summary(fit)
anova(fit)
catchCurve$PLUM<- fitted(fit)
catchCurve$PredictedSE<- predict(fit, se.fit =TRUE)$se.fit
catchCurve$residual<- residuals(fit)
catchCurve$rstudent<- rstudent(fit)
catchCurve$cookd<- cookd(fit)
catchCurve
sum(catchCurve$residual)
sum(catchCurve$residual^2)
plot(LNUM~AGE, catchCurve, xlab="Year-class",ylab="Natural log Number at
age", las=1)
points(PLUM~AGE, catchCurve, type="l")

# R code chunk 54 Catch curve analysis (Miranda and Bettoli, 2007).
setwd("C:/contEdCourseData/part2")
require(car);require(pda);require(lmtest);require(agricolae);require(MPV)
options(contrasts=c("contr.sum","contr.poly"))
ccurve <- read.csv("./box6_4.csv")
str(ccurve)
ccurve
ccurve$lCatch<- log(ccurve$Catch)
fit<- lm(lCatch~Age, ccurve, subset=Age>=3)
anova(fit)
ccurve$w<- predict(fit,ccurve)
fit<- lm(lCatch~Age, ccurve, subset=Age>=3,weights=w)
anova(fit)
coef(fit)
Z <- -coef(fit)[2]
Z
confidenceIntervals<- -confint(fit, "Age")
# PLOT THE CATCH AND MODEL PREDICTED CATCH
plot(lCatch~Age, ccurve,xlab="Age",ylab="Log(Catch)")
points(fitted(fit)~c(3:10),type="l",lwd=2)

# R code chunk 55 Catch curve variablility (Miranda and Bettoli, 2007).
setwd("C:/contEdCourseData/part2")
require(car);require(pda);require(lmtest);require(agricolae);require(MPV)
options(contrasts=c("contr.sum","contr.poly"))
ccurve_ancova <- read.csv("./box6_6.csv")
str(ccurve_ancova)
ccurve_ancova$Lake<- as.factor(ccurve_ancova$Lake)
ccurve_ancova$lCatch<- log(ccurve_ancova$Catch)
fit<- lm(lCatch~ Age, ccurve_ancova, subset=(Age>=2 & Lake=="1"))
summary(fit)
anova(fit)
fit<- lm(lCatch~Age, ccurve_ancova, subset=(Age>=2 & Lake==2))
summary(fit)
anova(fit)
fit<- lm(lCatch~Age+ Lake + Age:Lake, ccurve_ancova, subset=Age>=2)
ccurve_ancova$pred<- predict(fit, ccurve_ancova)
summary(fit)
anova(fit)
Anova(fit, type="III")
plot(fit)
plot(lCatch~Age, ccurve_ancova, type="n",xlab="Age",ylab="Log(Catch)")
points(lCatch~Age, ccurve_ancova,subset=Lake==1, col="grey")
points(lCatch~Age, ccurve_ancova,subset=Lake==2, col="black")
points(pred~Age, ccurve_ancova,subset=(Lake==1 & Age>=2),
col="grey",type="l")
points(pred~Age, ccurve_ancova,subset=(Lake==2 & Age>=2),
col="black",type="l")

# R code chunk 56 Weight-length data anlaysis (Pope and Kruse, 2007).
setwd("C:/contEdCourseData/part2")
condition <- read.csv("./box10_1.csv")
options(contrasts=c("contr.sum","contr.poly"))
str(condition)
head(condition)
plot(condition)
condition$lWT<- log10(condition$WT)
condition$lTL<- log10(condition$TL)
fit<- lm(lWT~lTL, condition, subset=pop=="a")
summary(fit);anova(fit);confint(fit)
fit<- lm(lWT~lTL, condition, subset=pop=="b")
summary(fit);anova(fit);confint(fit)
fit<- lm(lWT~lTL, condition, subset=pop=="c")
summary(fit);anova(fit);confint(fit)
fit<- nls(WT~a*TL^b, condition, subset=pop=="a", start=list(a=0.000001,
b=3))
summary(fit);confint(fit); summary(fit)$coefficients
fit<- nls(WT~a*TL^b, condition, subset=pop=="b", start=list(a=0.000001,
b=3))
summary(fit);confint(fit); summary(fit)$coefficients
fit<- nls(WT~a*TL^b, condition, subset=pop=="c", start=list(a=0.000001,
b=3))
summary(fit);confint(fit); summary(fit)$coefficients
fit<- lm(lWT~lTL*pop, condition)
summary(fit);anova(fit);confint(fit)
Anova(fit, type="III")
fit<- lm(lWT~lTL + pop, condition)
summary(fit);anova(fit);confint(fit)
Anova(fit, type="III")

R code chunk 57 Beaverton Holt spawner recruit curve (Page 151 Maceina and Pereira, 2007).
setwd("C:/contEdCourseData/part2")
require(car);require(pda);require(lmtest);require(agricolae);require(MPV)
options(contrasts=c("contr.sum","contr.poly"))
bvh <- read.csv("./box4_7.csv")
bvh$LRECRUIT<- bvh$RECRUIT
plot(RECRUIT~SPAWNER, bvh)
fit<- nls(RECRUIT~(a*SPAWNER)/(1+ b*SPAWNER), bvh, start=list(a=0.03,
b=0.002))
confint.default(fit)
fit1<- nls(RECRUIT~(SPAWNER)/(1+ b*SPAWNER), bvh, start=list( b=0.002 ))
confint.default(fit1)




